//+------------------------------------------------------------------+
//|  http://codebase.mql4.com/252                          Bands.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
//| BollingerBands_TRO_MODIFIED_VERSION                              |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Chocolate
#property indicator_color2 Chocolate
#property indicator_color3 Chocolate

//---- indicator parameters

extern bool   Show.Gauge  = true ;
extern int myChartX   = 10 ;
extern int myChartY   = 100 ;  
  
extern int myCorner   = 1 ;
extern string myFont  = "Courier New" ;
extern int myFontSize = 12 ;

extern bool   Show.PriceBox  = true ;
extern int       myLineWidth = 3;
extern int       myBoxWidth  = 3;

extern int    BandsPeriod=20;
extern int    BandsShift=0;
extern double BandsDeviations=2.0;

extern color colorHead = Orange ;
extern color colorTop  =  Chocolate ;
extern color colorMid  =  Chocolate ;
extern color colorBot  =  Chocolate ;
extern color colorUP   = Lime ;
extern color colorEQ   = Yellow ;
extern color colorDN   = Red ;

//---- buffers
double MovingBuffer[];
double UpperBuffer[];
double LowerBuffer[];

string Obj0001,Obj0002,Obj0003,Obj0004,Obj0005,Obj0006,Obj0007,Obj0008,Obj0009,Obj0010,Obj0011;  

int FillAmt = 11 , x001, x002, x003, x004, x005, x006, x007 ;   
 
string symbol, tChartPeriod, shortName, ShortName ;  

int    digits2, digits, period, win ; 

string lbl[15], lbl2[15];

int n, j ;
 

string ObjG001,ObjG002,ObjG003,ObjG004,ObjG005,ObjG006,ObjG007,ObjG008,ObjG009;  

double close, diff, value, point, range, xPct ;
color pColor = Blue ;
 
//+------------------------------------------------------------------+
int init()
  {
  
  
  
//---- indicators
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,myLineWidth,colorTop);
   SetIndexBuffer(0,MovingBuffer);
   SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,myLineWidth,colorMid);
   SetIndexBuffer(1,UpperBuffer);
   SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,myLineWidth,colorBot);
   SetIndexBuffer(2,LowerBuffer);
//----
   SetIndexDrawBegin(0,BandsPeriod+BandsShift);
   SetIndexDrawBegin(1,BandsPeriod+BandsShift);
   SetIndexDrawBegin(2,BandsPeriod+BandsShift);
//----

   Obj0002 = "bb002" ; 
   Obj0003 = "bb003" ;  
   Obj0004 = "bb004" ; 


   period = Period() ;  
      
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   ShortName    =  "bb"+symbol+period ;
   win          =  0 ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   

   shortName = "bb" ; 
 
   ObDeleteObjectsByPrefix(shortName);
   
if( myCorner == 0 || myCorner == 2 )
{ 
   x001 = 0 ;
   x002 = 0 ;
   x003 = 90 ; 
   x004 = 150;
   x005 = 100 ;
   x006 = 90 ;  
   x007 = 90 ;
   FillAmt = 20 ;     
}
else
{
   x001 = 0 ;
   x002 = 10 ; //  
   x003 = 60 ;  // val  
   x004 = 0 ; //  dif
   x005 = 10 ;
   x006 = 10 ;  
   x007 = 10 ;  
   FillAmt = 23 ; 
}

   return(0);
  }
  


//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
    
//+------------------------------------------------------------------+
int deinit()
  {
    
   ObDeleteObjectsByPrefix("bb");          
   TRO() ;
   
   return(0);
  }
   
  
  
//+------------------------------------------------------------------+
//| Bollinger Bands                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int    i,k,counted_bars=IndicatorCounted();
   double deviation;
   double sum,oldval,newres;
//----
   if(Bars<=BandsPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=BandsPeriod;i++)
        {
         MovingBuffer[Bars-i]=EMPTY_VALUE;
         UpperBuffer[Bars-i]=EMPTY_VALUE;
         LowerBuffer[Bars-i]=EMPTY_VALUE;
        }
//----
   int limit=Bars-counted_bars;
   if(counted_bars>0) limit++;
   for(i=0; i<limit; i++)
      MovingBuffer[i]=iMA(NULL,0,BandsPeriod,BandsShift,MODE_SMA,PRICE_CLOSE,i);
//----
   i=Bars-BandsPeriod+1;
   if(counted_bars>BandsPeriod-1) i=Bars-counted_bars-1;
   while(i>=0)
     {
      sum=0.0;
      k=i+BandsPeriod-1;
      oldval=MovingBuffer[i];
      while(k>=i)
        {
         newres=Close[k]-oldval;
         sum+=newres*newres;
         k--;
        }
      deviation=BandsDeviations*MathSqrt(sum/BandsPeriod);
      UpperBuffer[i]=oldval+deviation;
      LowerBuffer[i]=oldval-deviation;
      i--;
     }
//----


   if(Show.PriceBox) 
   {    
    if (ObjectFind(Obj0002) != 0)
      {
          ObjectCreate(Obj0002,OBJ_ARROW,0,Time[0],UpperBuffer[0]);
          ObjectSet(Obj0002,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(Obj0002,OBJPROP_COLOR,colorTop);  
          ObjectSet(Obj0002,OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(Obj0002,0,Time[0],UpperBuffer[0]);
         ObjectSet(Obj0002,OBJPROP_COLOR,colorTop);  
      }

    if (ObjectFind(Obj0003) != 0)
      {
          ObjectCreate(Obj0003,OBJ_ARROW,0,Time[0],LowerBuffer[0]);
          ObjectSet(Obj0003,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(Obj0003,OBJPROP_COLOR,colorBot);  
          ObjectSet(Obj0003,OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(Obj0003,0,Time[0],LowerBuffer[0]);
         ObjectSet(Obj0003,OBJPROP_COLOR,colorBot);  
      }

    if (ObjectFind(Obj0004) != 0)
      {
          ObjectCreate(Obj0004,OBJ_ARROW,0,Time[0],MovingBuffer[0]);
          ObjectSet(Obj0004,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(Obj0004,OBJPROP_COLOR,colorMid);  
          ObjectSet(Obj0004,OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(Obj0004,0,Time[0],MovingBuffer[0]);
         ObjectSet(Obj0004,OBJPROP_COLOR,colorMid);  
      }      
      
   } 
     
   if(Show.Gauge)  DoShowGauge();
   
   
   return(0);
  }
//+------------------------------------------------------------------+

void DoShowGauge()
{
n       = 10;
j       = 0 ;

close   = iClose(symbol,period,0) ;

lbl[j]  = ShortName+j;
lbl2[j] = fFill(tChartPeriod + " Bollinger(" +BandsPeriod +"," + DoubleToStr(BandsDeviations,1) +")"  , FillAmt) ;
DoShow(j, colorHead);

j       = j + 1;
lbl[j]  = ShortName+j;
value   = UpperBuffer[0] ;
diff    = (close - value) / point ;
DoColor(diff, 0) ;
lbl2[j] = fFill("Upper BB"  , FillAmt) ;
DoShow(j, pColor);

j       = j + 1;
lbl[j]  = ShortName+j;
value   = MovingBuffer[0] ;
diff    = (close - value) / point ;
DoColor(diff, 0) ;
lbl2[j] = fFill("Middle BB"  , FillAmt) ;
DoShow(j, pColor);

j       = j + 1;
lbl[j]  = ShortName+j;
value   = LowerBuffer[0] ;
diff    = (close - value) / point ;
DoColor(diff, 0) ;
lbl2[j] = fFill("Lower BB"  , FillAmt) ;
DoShow(j, pColor);


j       = j + 1;
lbl[j]  = ShortName+j;
value   = (UpperBuffer[0] - LowerBuffer[0]) / point  ;
diff    = 100* ( close - LowerBuffer[0]) /  (UpperBuffer[0] - LowerBuffer[0])  ;
DoColor(diff, 50) ;
lbl2[j] = fFill("Range| %"  , FillAmt) ;
DoShow(j, pColor);




}


//+------------------------------------------------------------------+
  
void DoShow( int u, color dsColor )
{

ObjectCreate(lbl[u],23,0,Time[0],PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE, x002+myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],lbl2[u],myFontSize,myFont,dsColor);

if(u > 0)
{
string Obj001 = lbl[u] + "val" ;
string sVal = fFill(DoubleToStr(value,digits), 7)    ;
ObjectCreate(Obj001,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj001, OBJPROP_CORNER, myCorner );
ObjectSet(Obj001,OBJPROP_XDISTANCE, x003+myChartX);
ObjectSet(Obj001,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj001,sVal,myFontSize,myFont,dsColor);


string Obj002 = lbl[u] + "dif" ;
string sDif =  rtadjust( DoubleToStr(diff,0) ) ;
ObjectCreate(Obj002,23,0,Time[0],PRICE_CLOSE);
ObjectSet(Obj002, OBJPROP_CORNER, myCorner );
ObjectSet(Obj002,OBJPROP_XDISTANCE, x004+myChartX);
ObjectSet(Obj002,OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(Obj002,sDif,myFontSize,myFont,dsColor);
}

n = n+20;

return(0);

}

//+------------------------------------------------------------------+
  
void DoColor( double c1, double c2 )
{

if(c1 > c2 ) { pColor = colorUP ; } else {
if(c1 < c2 ) { pColor = colorDN ; } else { pColor = colorEQ ; } } 

}  
   
//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}


//+------------------------------------------------------------------+


//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}



//+------------------------------------------------------------------+
string rtadjust( string rString )
{
 
 int sl = StringLen(rString) ;
 
 while(true)
 {
 
   if( sl == 5) { break ; } 
   if( sl == 4) { rString = " " + rString ; break ; }    
   if( sl == 3) { rString = "  " + rString ; break ; } 
   if( sl == 2) { rString = "   " + rString ; break ; } 
   if( sl == 1) { rString = "    " + rString ; break ; } 
    
   break ;
 }

return(rString) ;
}       


//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
//+--------- TRO MODIFICATION ---------------------------------------+  
//+------------------------------------------------------------------+